# Drupal recipe roadmap

## Phase 1

Main aim: to create the ability to apply an arbitrary recipe to a Drupal install

### To do
* [#3427558](https://www.drupal.org/project/distributions_recipes/issues/3427558)
  Output information from the recipe application process

### Done
* [#3292275](https://www.drupal.org/project/distributions_recipes/issues/3292275)
  Recipe class to read recipe.yml and composer.json
* [#3292281](https://www.drupal.org/project/distributions_recipes/issues/3292281#comment-14582069)
  Create recipe runner to process drupal-recipe recipe.yml files to
  install listed drupal extensions without their configuration entities
* [#3292282](https://www.drupal.org/project/distributions_recipes/issues/3292282)
  Extend recipe runner to create configuration provided in the recipe's
  /config folder
* [#3292284](https://www.drupal.org/project/distributions_recipes/issues/3292284)
  Extend recipe runner to allow recipe.yml to select configuration from
  installed modules
* [#3297426](https://www.drupal.org/project/distributions_recipes/issues/3297426)
  Enable a recipe to apply other recipes prior to by applied itself
* [#3284025](https://www.drupal.org/project/distributions_recipes/issues/3284025)
  Add configuration actions API
* [#3292285](https://www.drupal.org/project/distributions_recipes/issues/3292285)
  Add the ability to define configuration actions in recipes
* [#3292287](https://www.drupal.org/project/distributions_recipes/issues/3292287)
  Extend recipe runner to create content provided in the recipe's /content
  folder

## Phase 2

Main aims are to create a user interface for applying recipes and manage recipes
via composer.

TBD, includes:

* Building UI for applying recipes
* Hosting recipes on Drupal.org
* Discovery by some tool
* Drupal recipe testing
* Create composer plugin react when a drupal recipe is installed to unpack the
  recipe's dependencies and copy it to PROJECT_ROOT/recipes

### To do
* [#3401875](https://www.drupal.org/project/distributions_recipes/issues/3401875)
  Ensure that only one process can be applying a recipe at a time

## Phase 3

Main aim: to integrate with
the [Project Browser initiative](https://www.drupal.org/about/core/strategic-initiatives/project-browser)

TBD, includes:

* Project Browser integration
* [#2114713](https://www.drupal.org/project/drupal/issues/2114713) Project Browser in the installer
* CLI tools for creation

## Phase 4

TBD, includes:

* Dependabot / Symfony flex type updates
